﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using System.Web.Script.Serialization;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using SyncFusionTestProj.Models;


namespace SyncFusionTestProj.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public async Task<JsonResult> GetData()
        {
            try
            {
                var columns = new List<string>()
                {
                    "Facility Type", "Location", "Space Type", "Description", "Room", "SF", "Floor", "Building", "Key#", "Office Type",
                    "Subject", "Teacher/Occupant", "Max Occupancy", "Floor Covering (Main)", "Floor Covering (Main) Ratio",
                    "Floor Covering 2","Floor Covering 2 Ratio","Effective Date","AHS Number",
                };
                var data = new List<Dictionary<string, object>>();
                using (StreamReader r = new StreamReader("hello.json"))
                {
                    var json = r.ReadToEnd();
                    data = JsonConvert.DeserializeObject<List<Dictionary<string, object>>>(json);
                }

                return Json(new { Success = true, data = data, columns = columns });
            }
            catch
            {

                return Json(new { Success = false });
            }
        }

        public ActionResult ExportToExcel(string GridModel)
        {
            var data = new List<Dictionary<string, object>>();
            using (StreamReader r = new StreamReader("hello.json"))
            {
                var json = r.ReadToEnd();
                data = JsonConvert.DeserializeObject<List<Dictionary<string, object>>>(json);
            }

            ExcelExport exp = new ExcelExport();
            var DataSource = data.ToList();
            GridProperties gridProp = ConvertGridObject(GridModel);
            GridExcelExport excelExp = new GridExcelExport();
            excelExp.FileName = "Export.xlsx"; excelExp.Excelversion = ExcelVersion.Excel2010;
            excelExp.Theme = "flat-saffron";
            return exp.Export(gridProp, DataSource, excelExp);

        }




        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> data in div)
            {
                var property = gridProp.GetType().GetProperty(data.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(data.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }


        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }

}
